<?php
/**
 * @project Club
 * @file    wp_club_competitions.php
 * @class   Competition
 * @author  Alex Borras
 * @date    08-11-08
 * Class of table wp_club_competitions
 */
class Competition
{
/**
 * Class Competition
*/
function Competition($p_competition_id = 0)
{
    $num_args = func_num_args();
	// ID value or recordset
    if ($num_args >0)
    {
    	$this->select($p_competition_id);
    }
}
// Private Vars
private $competition_id;
private $competition_txt;
private $season_id;
private $sortorder;
private $exits;
private $col_teams       = array();
//**
//* Publics properties
//*
/**
* Return competition_id
*
* @return bigint(20)
*/
function get_competition_id()
{
	return $this->competition_id;
}
/**
* Set competition_id
*
* @return   void
*/
function set_competition_id($p_competition_id)
{
    $this->competition_id=$p_competition_id;
}
/**
* Return competition_txt
*
* @return varchar(100)
*/
function get_competition_txt()
{
	return $this->competition_txt;
}
/**
* Set competition_txt
*
* @return   void
*/
function set_competition_txt($p_competition_txt)
{
    $this->competition_txt=$p_competition_txt;
}
/**
* Return season_id
*
* @return bigint(20)
*/
function get_season_id()
{
	return $this->season_id;
}
/**
* Set season_id
*
* @return   void
*/
function set_season_id($p_season_id)
{
    $this->season_id=$p_season_id;
}
/**
* Return sortorder
*
* @return bigint(20)
*/
function get_sortorder()
{
	return $this->sortorder;
}
/**
* Set sortorder
*
* @return   void
*/
function set_sortorder($p_sortorder)
{
    $this->sortorder=$p_sortorder;
}
/**
* Return existe
*
* @return boolean
*/
function get_existe()
{
	return $this->existe;
}
/**
* Set existe
*
* @return   void
*/
function set_existe($p_existe)
{
    $this->existe=$p_existe;
}
/**
 * Return Teams collection sorted by Scores
 * @return array
 */
function get_teams()
{
	$col = array();
    $col = get_col_competition_teams($this->get_competition_id());
    return $col;
}
/**
 * Return Gameweeks collection sorted by GameWeek
 * @return array
 */
function get_gameweeks()
{
	$col = array();
    $col = get_col_competition_gameweeks($this->get_competition_id());
    return $col;
}
//**
//* Publics Methods
//*
function select($p_competition_id)
{
    // Se est pasando un recordset
	if (is_object($p_competition_id) )
	{
		$this->fill_properties($p_competition_id);
		return;
	}
	// Tratamiento de Acceso para cdigo numricos
	$sql = "SELECT * FROM wp_club_competitions ";
	if (is_numeric($p_competition_id) ) // Se est pasando el identificador
	{
		$sql.= "WHERE competition_id=".$p_competition_id;
	}
   global $wpdb;
   $this->exits = false;
   $rst = $wpdb->get_results($sql);
   if ( $rst ) {
      foreach( $rst as $row ) {
		   $this->exits = true;
	       $this->fill_properties($row);
      }
   }
}
function fill_properties($p_row)
	// Fill class properties
{
    $this->competition_id = $p_row->competition_id;
    $this->competition_txt = $p_row->competition_txt;
    $this->season_id = $p_row->season_id;
    $this->sortorder = $p_row->sortorder;
}
/**
* Method 
*
* @return   void
*/
function addnew()
	// Insert new data
{
    $sql = "INSERT INTO wp_club_competitions SET ";
    $sql.= $this->fill_sql_properties();
    global $wpdb;
    $wpdb->query($sql);
}
/**
* Method 
*
* @return   void
*/
function update()
{
	// Modify data, properties must be filled
	$sql = "UPDATE wp_club_competitions SET ";
	$sql.= $this->fill_sql_properties();
    $sql.= " WHERE competition_id=". $this->competition_id ." LIMIT 1;";
    global $wpdb;
    $wpdb->query($sql);
}
/**
* Method 
*
* @return   void
*/
function delete()
{
    // Delete data
	$sql = "DELETE FROM wp_club_competitions ";
    $sql.= " WHERE competition_id=". $this->competition_id ." LIMIT 1;";
    global $wpdb;
    $wpdb->query($sql);
}
/**
 * Fille properties for SQL query Insert and Update
 *
 * @return   string
*/
function fill_sql_properties()
{
       $sql.= "competition_txt='".$this->competition_txt."',";
       $sql.= "season_id='".$this->season_id."',";
       $sql.= "sortorder='".$this->sortorder."',";
    $sql = substr($sql, 0, -1)." "; // del last quote
    return $sql;
}
/**
* Return Tab of data Class
*
@return   string
*/
function show($p_view = "estandar")
{
	switch ($p_view)
	{
		case "estandar":
			return $str;
			break;
	}
}
// Add manually
//End Class
}
?>