<?php
/**
 * @project Club
 * @file    wp_club_documents.php
 * @class   Document
 * @author  Alex Borras
 * @date    2424-0101-09090909
 * Class of table wp_club_documents
 */
class Document
{
/**
 * Class Document
*/
function Document($p_document_id = 0)
{
    $num_args = func_num_args();
	// ID value or recordset
    if ($num_args >0)
    {
    	$this->select($p_document_id);
    }
}
// Private Vars
private $document_id;
private $document_txt;
private $table_txt;
private $source_id;
private $type;
private $document_date;
private $remarks;
private $exits;
//**
//* Publics properties
//*
/**
* Return document_id
*
* @return bigint(20)
*/
function get_document_id()
{
	return $this->document_id;
}
/**
* Set document_id
*
* @return   void
*/
function set_document_id($p_document_id)
{
    $this->document_id=$p_document_id;
}
/**
* Return document_txt
*
* @return varchar(100)
*/
function get_document_txt()
{
	return $this->document_txt;
}
/**
* Set document_txt
*
* @return   void
*/
function set_document_txt($p_document_txt)
{
    $this->document_txt=$p_document_txt;
}
/**
* Return table_txt
*
* @return varchar(100)
*/
function get_table_txt()
{
	return $this->table_txt;
}
/**
* Set table_txt
*
* @return   void
*/
function set_table_txt($p_table_txt)
{
    $this->table_txt=$p_table_txt;
}
/**
* Return source_id
*
* @return bigint(20)
*/
function get_source_id()
{
	return $this->source_id;
}
/**
* Set source_id
*
* @return   void
*/
function set_source_id($p_source_id)
{
    $this->source_id=$p_source_id;
}
/**
* Return type
*
* @return varchar(100)
*/
function get_type()
{
	return $this->type;
}
/**
* Set type
*
* @return   void
*/
function set_type($p_type)
{
    $this->type=$p_type;
}
/**
* Return document_date
*
* @return datetime
*/
function get_document_date()
{
	return $this->document_date;
}
/**
* Set document_date
*
* @return   void
*/
function set_document_date($p_document_date)
{
    $this->document_date=$p_document_date;
}
/**
* Return remarks
*
* @return text
*/
function get_remarks()
{
	return $this->remarks;
}
/**
* Set remarks
*
* @return   void
*/
function set_remarks($p_remarks)
{
    $this->remarks=$p_remarks;
}
/**
* Return existe
*
* @return boolean
*/
function get_existe()
{
	return $this->existe;
}
/**
* Set existe
*
* @return   void
*/
function set_existe($p_existe)
{
    $this->existe=$p_existe;
}
//**
//* Publics Methods
//*
function select($p_document_id)
{
    // Se est pasando un recordset
	if (is_object($p_document_id) )
	{
		$this->fill_properties($p_document_id);
		return;
	}
	// Tratamiento de Acceso para cdigo numricos
	$sql = "SELECT * FROM wp_club_documents ";
	if (is_numeric($p_document_id) ) // Se est pasando el identificador
	{
		$sql.= "WHERE document_id=".$p_document_id;
	}
   global $wpdb;
   $this->exits = false;
   $rst = $wpdb->get_results($sql);
   if ( $rst ) {
      foreach( $rst as $row ) {
		   $this->exits = true;
	       $this->fill_properties($row);
      }
   }
}
function fill_properties($p_row)
	// Fill class properties
{
    $this->document_id = $p_row->document_id;
    $this->document_txt = $p_row->document_txt;
    $this->table_txt = $p_row->table_txt;
    $this->source_id = $p_row->source_id;
    $this->type = $p_row->type;
    $this->document_date = $p_row->document_date;
    $this->remarks = $p_row->remarks;
}
/**
* Method 
*
* @return   void
*/
function addnew()
	// Insert new data
{
    $sql = "INSERT INTO wp_club_documents SET ";
    $sql.= $this->fill_sql_properties();
    global $wpdb;
    $wpdb->query($sql);
    $this->document_id = $wpdb->insert_id;
}
/**
* Method 
*
* @return   void
*/
function update()
{
	// Modify data, properties must be filled
	$sql = "UPDATE wp_club_documents SET ";
	$sql.= $this->fill_sql_properties();
    $sql.= " WHERE document_id=". $this->document_id ." LIMIT 1;";
    global $wpdb;
    $wpdb->query($sql);
}
/**
* Method 
*
* @return   void
*/
function delete()
{
    // Delete data
	$sql = "DELETE FROM wp_club_documents ";
    $sql.= " WHERE document_id=". $this->document_id ." LIMIT 1;";
    global $wpdb;
    $wpdb->query($sql);
}
/**
 * Fille properties for SQL query Insert and Update
 *
 * @return   string
*/
function fill_sql_properties()
{
       $sql.= "document_txt='".$this->document_txt."',";
       $sql.= "table_txt='".$this->table_txt."',";
       $sql.= "source_id='".$this->source_id."',";
       $sql.= "type='".$this->type."',";
       $sql.= "document_date='".$this->document_date."',";
       $sql.= "remarks='".$this->remarks."',";
    $sql = substr($sql, 0, -1)." "; // del last quote
    return $sql;
}
function get_path(){
	$fileglob = CLUBUPLOADS."/".$this->get_table_txt()."/".$this->get_document_id().".*";
	foreach (glob($fileglob) as $filename){
		return CLUBUPLOADSURL."/".$this->get_table_txt()."/".file_shortname($filename);
	}
}
/** Return file Path form id document 
* @return string
* @param int $p_format =   1  Return path 
*                          2  Return text with hyperlink path
* 						 101  Return img tag & hyperlink
* 						 102  Return img tag 
* @param $p_height = 230 Tamao de la foto (230 = estandar, 80 = Gallery)
*/
function get_file($p_table_txt, $p_source_id, $p_type = "picture", $p_format = 1, $p_height = 230){
	global $wpdb;
	$sql = "SELECT * FROM wp_club_documents ";
	$sql.= "WHERE table_txt='$p_table_txt' AND source_id='$p_source_id' AND type='$p_type' "; // Not LIMIT 1 why if document no exists 
	//echo $sql;
	$rst = $wpdb->get_results($sql);
    if ( $rst ) {
		foreach( $rst as $row ) {
		   $this->fill_properties($row);
		   $filename = $this->get_path();
		   if (file_exists($filename)){
		       break;
		   }
		}
    }
    $return = false;
    switch ($p_format){
    	case 1:
    		$return = $filename;
    		break;
    	case 2:
    		$return = "<a href=\"$filename\" title=\"{$this->get_document_txt()}\">{$this->get_document_txt()}</a>";
    		break;
    	case 101:
    		$return = "<a href=\"$filename\" title=\"{$this->get_document_txt()}\"><img src=\"$filename\" height=\"$p_height\" border=\"0\" alt=\"{$this->get_document_txt()}\"></a>";
    		break;
    	case 102:
    		$return = "<img src=\"$filename\" height=\"$p_height\" border=\"0\" alt=\"{$this->get_document_txt()}\">";
    		break;
    	default:
    		$return = "<a href=\"$filename\" title=\"{$this->get_document_txt()}\">{$this->get_document_txt()}</a>";
    		break;
    }
    return $return;
}
/**
* @return   void
* Set odcument
*/
function set_file($p_file, $p_table_txt, $p_source_id, $p_type = "picture"){
	// File data
	$name = $p_file['name'];
	$tmp  = $p_file['tmp_name'];
	$ext  = file_extension($name);
	if ($tmp == ""){
		//echo "<br>No File";
		return false; // 
	}
	elseif (file_exists($tmp) == false){
		//echo "<br>File $tmp not found";
		return false; // File no exits
	}
	/*
	if (filesize($p_document) > 105600){ // max 100 KB
		return false;
	}*/
	// Create data
	$this->set_table_txt($p_table_txt);
	$this->set_source_id($p_source_id);
	$this->set_type($p_type);
	$this->addnew();
	// Copy File
	$fileweb = CLUBUPLOADS."/".$this->get_table_txt()."/{$this->document_id}.$ext";
	//echo "<br>$name<br>$tmp<br>$fileweb<br>";
	if (file_exists($fileweb)){
		unlink($fileweb);
	}
	// Move file
	if (move_uploaded_file($tmp,$fileweb)){
	    return true;
	}
	else{
		echo "Error in move_uploaded_file";
	    return false;
	}
}
/**
* Return Tab of data Class
*
@return   string
*/
function show($p_view = "estandar")
{
	switch ($p_view)
	{
		case "estandar":
			return $str;
			break;
	}
}
//End Class
}
?>
