<?php
/**
 * @project Club
 * @file    wp_club_match.php
 * @class   Match
 * @author  Alex Borras
 * @date    2929-1111-08080808
 * Class of table wp_club_match
 */
class Match
{
/**
 * Class Match
*/
function Match($p_match_id = 0)
{
    $num_args = func_num_args();
	// ID value or recordset
    if ($num_args >0)
    {
    	$this->select($p_match_id);
    }
}
// Private Vars
private $match_id;
private $competition_id;
private $field_id;
private $gameweek;
private $played;
private $match_date;
private $team_home_id;
private $team_away_id;
private $goals_home;
private $goals_away;
private $exits;
//**
//* Publics properties
//*
/**
* Return match_id
*
* @return bigint(20)
*/
function get_match_id()
{
	return $this->match_id;
}
/**
* Set match_id
*
* @return   void
*/
function set_match_id($p_match_id)
{
    $this->match_id=$p_match_id;
}
/**
* Return competition_id
*
* @return bigint(20)
*/
function get_competition_id()
{
	return $this->competition_id;
}
/**
* Set competition_id
*
* @return   void
*/
function set_competition_id($p_competition_id)
{
    $this->competition_id=$p_competition_id;
}
/**
* Return field_id
*
* @return bigint(20)
*/
function get_field_id()
{
	return $this->field_id;
}
/**
* Set field_id
*
* @return   void
*/
function set_field_id($p_field_id)
{
    $this->field_id=$p_field_id;
}
/**
* Return gameweek
*
* @return varchar(4)
*/
function get_gameweek()
{
	return $this->gameweek;
}
/**
* Set gameweek
*
* @return   void
*/
function set_gameweek($p_gameweek)
{
    $this->gameweek=$p_gameweek;
}
/**
* Return played
*
* @return varchar(4)
*/
function get_played()
{
	return $this->played;
}
/**
* Set played
*
* @return   void
*/
function set_played($p_played)
{
    $this->played=$p_played;
}
/**
* Return match date
*
* @return datetime
*/
function get_match_date()
{
	$date = strtotime($this->match_date);
	if (date("Y",$date) > "1970" ){
		return strftime("%d-%m-%Y %H:%M", $date);
	}else{
		return "";
	}
}
/**
* Set match_date
*
* @return   void
*/
function set_match_date($p_match_date)
{
    $this->match_date=$p_match_date;
}
/**
* Return team_home_id
*
* @return bigint(20)
*/
function get_team_home_id()
{
	return $this->team_home_id;
}
/**
* Set team_home_id
*
* @return   void
*/
function set_team_home_id($p_team_home_id)
{
    $this->team_home_id=$p_team_home_id;
}
/**
* Return team_away_id
*
* @return bigint(20)
*/
function get_team_away_id()
{
	return $this->team_away_id;
}
/**
* Set team_away_id
*
* @return   void
*/
function set_team_away_id($p_team_away_id)
{
    $this->team_away_id=$p_team_away_id;
}
/**
* Return goals_home
*
* @return int(3)
*/
function get_goals_home()
{
	return $this->goals_home;
}
/**
* Set goals_home
*
* @return   void
*/
function set_goals_home($p_goals_home)
{
    $this->goals_home=$p_goals_home;
}
/**
* Return goals_away
*
* @return int(3)
*/
function get_goals_away()
{
	return $this->goals_away;
}
/**
* Set goals_away
*
* @return   void
*/
function set_goals_away($p_goals_away)
{
    $this->goals_away=$p_goals_away;
}
/**
* Return existe
*
* @return boolean
*/
function get_existe()
{
	return $this->existe;
}
/**
* Set existe
*
* @return   void
*/
function set_existe($p_existe)
{
    $this->existe=$p_existe;
}
// Add Manually
/**
 * Get Result of Match
 *
 * @param unknown_type $p_match_id
 */
function get_result()
{
	if ($this->get_played() == true){
		return $this->get_goals_home()." - ".$this->get_goals_away();
	} else {
		return "";
	}
}
/**
 * Returns Field Object, Friendly class of Match
 *
 * @return Field
 */
function get_field()
{
    $obj = new Field($this->get_field_id());
    return $obj;
}
/**
 * Returns Team Home Object, Friendly class of Match
 *
 * @return Team
 */
function get_team_home()
{
    $obj = new Team($this->get_team_home_id());
    return $obj;
}
/**
 * Returns Team Away Object, Friendly class of Match
 *
 * @return Genero
 */
function get_team_away()
{
    $obj = new Team($this->get_team_away_id());
    return $obj;
}
//**
//* Publics Methods
//*
function select($p_match_id)
{
    // Se est pasando un recordset
	if (is_object($p_match_id) )
	{
		$this->fill_properties($p_match_id);
		return;
	}
	// Tratamiento de Acceso para cdigo numricos
	$sql = "SELECT * FROM wp_club_matches ";
	if (is_numeric($p_match_id) ) // Se est pasando el identificador
	{
		$sql.= "WHERE match_id=".$p_match_id;
	}
   global $wpdb;
   $this->exits = false;
   $rst = $wpdb->get_results($sql);
   if ( $rst ) {
      foreach( $rst as $row ) {
		   $this->exits = true;
	       $this->fill_properties($row);
      }
   }
}
function fill_properties($p_row)
	// Fill class properties
{
    $this->match_id = $p_row->match_id;
    $this->competition_id = $p_row->competition_id;
    $this->field_id = $p_row->field_id;
    $this->gameweek = $p_row->gameweek;
    $this->played = $p_row->played;
    $this->match_date = $p_row->match_date;
    $this->team_home_id = $p_row->team_home_id;
    $this->team_away_id = $p_row->team_away_id;
    $this->goals_home = $p_row->goals_home;
    $this->goals_away = $p_row->goals_away;
}
/**
* Method 
*
* @return   void
*/
function addnew()
	// Insert new data
{
    $sql = "INSERT INTO wp_club_matches SET ";
    $sql.= $this->fill_sql_properties();
    global $wpdb;
    $wpdb->query($sql);
}
/**
* Method 
*
* @return   void
*/
function update()
{
	// Modify data, properties must be filled
	$sql = "UPDATE wp_club_matches SET ";
	$sql.= $this->fill_sql_properties();
    $sql.= " WHERE match_id=". $this->match_id ." LIMIT 1;";
    global $wpdb;
    $wpdb->query($sql);
}
/**
* Method 
*
* @return   void
*/
function delete()
{
    // Delete data
	$sql = "DELETE FROM wp_club_matches ";
    $sql.= " WHERE match_id=". $this->match_id ." LIMIT 1;";
    global $wpdb;
    $wpdb->query($sql);
}
/**
 * Fille properties for SQL query Insert and Update
 *
 * @return   string
*/
function fill_sql_properties()
{
       $sql.= "competition_id='".$this->competition_id."',";
       $sql.= "field_id='".$this->field_id."',";
       $sql.= "gameweek='".$this->gameweek."',";
       $sql.= "played='".$this->played."',";
       $sql.= "match_date='".$this->match_date."',";
       $sql.= "team_home_id='".$this->team_home_id."',";
       $sql.= "team_away_id='".$this->team_away_id."',";
       $sql.= "goals_home='".$this->goals_home."',";
       $sql.= "goals_away='".$this->goals_away."',";
    $sql = substr($sql, 0, -1)." "; // del last quote
    return $sql;
}
/**
* Return Tab of data Class
*
@return   string
*/
function show($p_view = "estandar")
{
	switch ($p_view)
	{
		case "estandar":
			return $str;
			break;
	}
}
//End Class
}
?>
