<?php
/**
 * @project wp-club
 * @file    wp_club_settings.php
 * @class   Settings
 * @author  Alex Borras
 * @date    0606-0707-08080808
 * Class of table wp_club_settings
 */
class Settings
{
/**
 * Class Settings
*/
function Settings($p_settings_id = 0)
{
    $num_args = func_num_args();
	// ID value or recordset
    if ($num_args >0)
    {
    	$this->select($p_settings_id);
    }
}
// Private Vars
private $settings_id;
private $season_id;
private $delete_tables_uninstall;
private $table_header_style;
private $exits;
//**
//* Publics properties
//*
/**
* Return settings_id
*
* @return smallint(1)
*/
function get_settings_id()
{
	return $this->settings_id;
}
/**
* Set settings_id
*
* @return   void
*/
function set_settings_id($p_settings_id)
{
    $this->settings_id=$p_settings_id;
}
/**
* Return season_id
*
* @return bigint(4)
*/
function get_season_id()
{
	return $this->season_id;
}
/**
* Set season_id
*
* @return   void
*/
function set_season_id($p_season_id)
{
    $this->season_id=$p_season_id;
}
/**
* Return delete_tables_uninstall
*
* @return tinyint(2)
*/
function get_delete_tables_uninstall()
{
	return $this->delete_tables_uninstall;
}
/**
* Set delete_tables_uninstall
*
* @return   void
*/
function set_delete_tables_uninstall($p_delete_tables_uninstall)
{
    $this->delete_tables_uninstall=$p_delete_tables_uninstall;
}

/**
* Return header_table_style
*
* @return text
*/
function get_table_header_style()
{
	return $this->table_header_style;
}
/**
* Set header_table_style
*
* @return   void
*/
function set_table_header_style($p_table_header_style)
{
    $this->table_header_style=$p_table_header_style;
}

/**
* Return existe
*
* @return boolean
*/
function get_existe()
{
	return $this->existe;
}
/**
* Set existe
*
* @return   void
*/
function set_existe($p_existe)
{
    $this->existe=$p_existe;
}
//**
//* Publics Methods
//*
function select($p_settings_id)
{
    // Se est pasando un recordset
	if (is_object($p_settings_id) )
	{
		$this->fill_properties($p_settings_id);
		return;
	}
	// Tratamiento de Acceso para cdigo numricos
	$sql = "SELECT * FROM wp_club_settings ";
	if (is_numeric($p_settings_id) ) // Se est pasando el identificador
	{
		$sql.= "WHERE settings_id=".$p_settings_id;
	}
   global $wpdb;
   //echo "<br>$sql<br>";
   $this->exits = false;
   $rst = $wpdb->get_results($sql);
   if ( $rst ) {
      foreach( $rst as $row ) {
		   $this->exits = true;
	       $this->fill_properties($row);
      }
   }
}
function fill_properties($p_row)
	// Fill class properties
{
    $this->settings_id             = $p_row->settings_id;
    $this->season_id               = $p_row->season_id;
    $this->delete_tables_uninstall = $p_row->delete_tables_uninstall;
    $this->table_header_style      = $p_row->table_header_style;
}
/**
* Method 
*
* @return   void
*/
function addnew()
	// Insert new data
{
    $sql = "INSERT INTO wp_club_settings SET ";
    $sql.= $this->fill_sql_properties();
    global $wpdb;
    $wpdb->query($sql);
}
/**
* Method 
*
* @return   void
*/
function update()
{
	// Modify data, properties must be filled
	$sql = "UPDATE wp_club_settings SET ";
	$sql.= $this->fill_sql_properties();
    $sql.= " WHERE settings_id=". $this->get_settings_id() ." LIMIT 1;";
    //echo "sql:$sql";
    global $wpdb;
    $wpdb->query($sql);
}
/**
* Method 
*
* @return   void
*/
function delete()
{
    // Delete data
	$sql = "DELETE FROM wp_club_settings ";
    $sql.= " WHERE settings_id=". $this->settings_id ." LIMIT 1;";
    global $wpdb;
    $wpdb->query($sql);
}
/**
 * Fille properties for SQL query Insert and Update
 *
 * @return   string
*/
function fill_sql_properties()
{
       $sql.= "season_id='".$this->season_id."',";
       $sql.= "delete_tables_uninstall='".$this->delete_tables_uninstall."',";
       $sql.= "table_header_style='"     .$this->table_header_style."',";
    $sql = substr($sql, 0, -1)." "; // del last quote
    return $sql;
}
/**
* Return Tab of data Class
*
@return   string
*/
function show($p_view = "estandar")
{
	switch ($p_view)
	{
		case "estandar":
			return $str;
			break;
	}
}
//End Class
}
?>
